<template>
  <div class="modal">
    <b-modal
      ref="detalisModal"
      id="detalisModal"
      scrollable
      centered
      v-model="$store.state.showModal"
      @show="getInit(items.rocket, items.launchpad)"
      @close="$emit('close')"
    >
      <b-card class="text-center border-0">
        <b-card-text class="border-bottom">
          <h3>{{ items.name }}</h3>
          <p>{{ currentDateTime(items.date_utc) }}</p>
        </b-card-text>
        <b-card-text class="border-bottom">
          <b-button variant="primary">Crews</b-button>
          <b-row class="my-2 py-3">
            <b-col cols="12">
              <b-avatar-group class="text-center" size="80px">
                <div v-for="item in crews" :key="item.index" class="mx-2">
                  <b-avatar :src="item.image"> </b-avatar>
                  <p>{{ item.name }}</p>
                </div>
              </b-avatar-group>
            </b-col>
          </b-row>
        </b-card-text>
        <b-card-text v-if="rocket != null" class="border-bottom">
          <b-button variant="primary">Rocket</b-button>
          <b-row class="my-2 py-3">
            <b-col cols="12">
              <h6>{{ rocket.name }}</h6>
            </b-col>
            <b-col cols="12">
              <b-img :src="rocket.flickr_images[0]" fluid-grow></b-img>
            </b-col>
          </b-row>
        </b-card-text>
        <b-card-text v-if="launchpads != null" class="border-bottom">
          <b-button variant="primary">Launchpad</b-button>
          <b-row class="my-2 py-3">
            <b-col cols="12">
              <h6 class="text-center">{{ launchpads.full_name }}</h6>
            </b-col>
          </b-row>
        </b-card-text>
        <b-card-text v-if="launchpads != null" class="border-bottom">
          <b-button variant="primary">Details</b-button>
          <b-row class="my-2 py-3">
            <b-col cols="12">
              <h6 class="text-left">{{ launchpads.details }}</h6>
            </b-col>
          </b-row>
        </b-card-text>
      </b-card>
    </b-modal>
  </div>
</template>

<script>
import moment from "moment";
export default {
  name: "Modal",
  data() {
    return {
      crews: null,
      rocket: null,
      launchpads: null
    };
  },
  props: {
    isShowModal: Boolean,
    items: Object,
  },
  methods: {
    currentDateTime(staticFireDate) {
      return moment(staticFireDate).format("ddd MMM DD YYYY HH:mm:ss");
    },
    getInit(rocketId, launchpadsId) {
      this.getCrews();
      this.getRocket(rocketId);
      this.getLaunchpads(launchpadsId);
    },
    getCrews() {
      this.axios
        .post("https://api.spacexdata.com/v4/crew/query")
        .then((response) => {
          this.crews = response.data.docs;
          console.log("Crews:---->", this.crews);
        });
    },
    getRocket(id) {
      this.axios
        .get("https://api.spacexdata.com/v4/rockets/" + id)
        .then((response) => {
          this.rocket = response.data;
          console.log("Rocket:---->", this.rocket);
        });
    },
    getLaunchpads(id) {
      this.axios
        .get("https://api.spacexdata.com/v4/launchpads/" + id)
        .then((response) => {
          this.launchpads = response.data;
          console.log("Launchpads:---->", this.launchpads);
        });
    },
  },
};
</script>

<style lang="scss">
.b-avatar-group-inner {
  justify-content: center;
}
.card-text .btn {
  border-radius: 20px;
  background-color: #4c4caf !important;
  border-color: #4c4caf !important;
}
</style>